// *****************************************************************************************************
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// *****************************************************************************************************
// File name    : i2c_master_logic.v
// Module name  : i2c_master_logic
// Author       : STEP_Zhang Ze
// Description  : i2c_master˽ӿò֡
// Web          : www.stepfpga.com
// 
// -----------------------------------------------------------------------------------------------------
// Code Revision History : V1.0
// -----------------------------------------------------------------------------------------------------
// Version: |Mod. Date:   |Changes Made:
// V1.0     |2017/03/02   |Initial ver
// -----------------------------------------------------------------------------------------------------
// Module Function:i2c_master˽ӿò֡
//
// -----------------------------ӿ˵-----------------------------------------------------------------
//
//	1.i2c_clk
//		100KHz/400Khz.
//
//	2.rst_n:
//		͵ƽЧ첽λź
//
//	3.write_done
//		ÿдɹ᷵1θߵƽ塣
//	
//	4.i2c_read_data
//		ȡݣĬֵλ8h00
//	
//	5.i2c_configźŸʽ
//		i2c_config = {豸ַ/дƣ/ζȡ/дĿĴַдĴ}
//						7bit	1bit		1bit			8bit			8bit
//		e.g.
//			1.д豸ַ0X50,дĿĴ0X16,д0XAA
//				i2c_config = {7'h50,1'b0,1'bX,8'h16,8'hAA}; ע⣺д/ζȡλЧ,1λֵա
//			2.ζȡ豸ַ0X48ȡĿĴ0X00ζȡ
//				i2c_config = {7'h48,1'b1,1'b0,8'h00,8'hXX};	ע⣺ȡдĴݡЧ,8λֵա
//
//------------------------------------------------------------------------------------------------------

module i2c_master_config(
							i2c_clk,		
							rst_n,
							scl,
							sda,
							i2c_read_data,
							write_done,
							i2c_config
							);
	
	input			i2c_clk;			//ʱܽţ100K or 400K;
	input			rst_n;				//λźţ͵ƽЧ
	output			scl;				//I2Cʱź
	inout			sda;				//I2Cź
	output	[7:0]	i2c_read_data;		//I2C
	output			write_done;			//дɱ־
	input	[24:0]	i2c_config;			//I2Cܽ
	
	wire	[6:0]	i2c_device_address;	//豸ַ
	wire			w_r_control;		//дλ
	wire			continuous_read;	//дλ
	wire	[7:0]	i2c_reg_address;	//I2C/дĿĴַ
	wire	[7:0]	i2c_write_reg_data;	//I2Cд
	
	assign 	i2c_device_address 	= i2c_config[24:18];	
	assign	w_r_control			= i2c_config[17];
	assign	continuous_read 	= i2c_config[16];
	assign	i2c_reg_address		= i2c_config[15:8];
	assign	i2c_write_reg_data 	= i2c_config[7:0];
	
	i2c_master_logic i2c_master_logic_inst(
		.clk_in(i2c_clk),
		.rst_n(rst_n),
		.scl(scl),
		.sda(sda),
		.i2c_read_data(i2c_read_data),
		.i2c_device_address(i2c_device_address),
		.w_r_control(w_r_control),
		.i2c_reg_address(i2c_reg_address),
		.i2c_write_reg_data(i2c_write_reg_data),
		.write_done(write_done),
		.continuous_read(continuous_read)
		);
	    
endmodule
